---
categories: web
title: Howto Crontab
...

La commande `crontab` permet d'éditer/lister/supprimer les tâches planifiées gérées par le service **cron**. Pour plus de détails sur l'administration système d'un service cron, voir [HowtoCron]().

## Gestion de votre crontab

Via un accès SSH, vous pouvez gérer votre crontab.

Pour lister votre crontab :

~~~
$ crontab -l
~~~

Pour éditer votre crontab via l'éditeur par défaut (souvent Vim) :

~~~
$ crontab -e
~~~

> _Note :_ attention, _crontab -r_ efface définitivement toute votre crontab, donc méfiez-vous car la touche `r` est proche de la touche `e` sur un clavier Azerty ou Qwerty.

Pour éditer votre crontab via un autre éditeur (par exemple _pico_) :

~~~
$ EDITOR=pico crontab -e
~~~

## Exemples de crontab

Attention, si une ligne de votre crontab a une syntaxe incorrecte, toute votre crontab risque d'être considérée comme invalide.

Veuillez également lire ces conseils : [TipsDevWeb#scripts-en-crontab]()

Lancer la commande _date_ tous les jours à minuit :

~~~
@daily date
~~~

Lancer la commande tous les dimanches à 6h42 :

~~~
42 6 * * 0 date
~~~

Lancer la commande tous les 4h en commençant à 7h35.

~~~
35 7-23/4 * * *
~~~

Pour plus d'informations sur la syntaxe, vous pouvez utiliser la commande : [man 5 crontab](https://manpages.debian.org/jessie/cron/crontab.5.en.html)