# Howto Roundcube

Sous licence libre GPL, roundcube est un client de messagerie utilisant l'IMAP.
D'autres alternatives existent tel que rainloop, SOGo, Squirrelmail,...

## Installation 

Rien de plus simple :

~~~
# apt install roundcube
~~~

Le fichier de configuration principale est `/etc/roundcube/defaults.inc.php`

## Plugin sieve

Celui-ci permet l'usage des filtres.

~~~
# apt install roundcube-plugins-extra
~~~

On pourra l'activer ainsi :

~~~
$config['plugins'] = array('sieverules');
~~~

La configuration des règles se ferront dans `/etc/roundcube/plugins/sieverules/config.inc.php`.

## Plugin vacation

Il est utilisé lorsque l'utilisateur du compte mail est en vacances par exemple.

<http://sourceforge.net/projects/rcubevacation/>

Patch UTF-8 : <http://paste.evolix.org/paste/117/>

## Plugin password

Son utilisé résulte sur la possibilité de changer son propre mot de passe avec de nombreux connecteurs tel que dovecot, LDAP, etc.

On pourra l'activer ainsi :

~~~
$config['plugins'] = array('sieverules');
~~~

Pour les comptes mails stockés dans LDAP il faudra installer `php-net-ldap2` et mettre en place le fichier `/etc/roundcube/plugins/password/config.inc.php` suivant :

~~~
<?php
$rcmail_config['password_driver'] = 'ldap';
$rcmail_config['password_minimum_length'] = 6;
$rcmail_config['password_ldap_host'] = 'localhost';
$rcmail_config['password_ldap_port'] = '389';
$rcmail_config['password_ldap_version'] = '3';
$rcmail_config['password_ldap_basedn'] = 'dc=example,dc=com';
$rcmail_config['password_ldap_method'] = 'user';
$rcmail_config['password_ldap_search_filter'] = '(uid=%login)';
$rcmail_config['password_ldap_pwattr'] = 'userPassword';
$rcmail_config['password_ldap_encodage'] = 'ssha';
?>
~~~

## Mailbox doesn’t exist

Si nous avons par exemple l'erreur suivante : "UID MOVE : Mailbox doesn’t exist : Trash"

On devra activer cette option :

~~~
$config['create_default_folders'] = true;
~~~

## Mode debug

Activer la directive suivante :

~~~
$config['imap_debug'] = true;
~~~

Les messages d'erreurs seronts dans le log /var/log/syslog

## Import de contacts en CSV 

<https://www.pokorra.de/2017/01/import-contacts-via-csv-into-roundcube/>
