---
title: Howto Tsung
categories: tips network utilities tools sysadmin 
...

* Site officiel : <http://tsung.erlang-projects.org/>
* Manuel de Tsung : <http://tsung.erlang-projects.org/user_manual.html>

Tsung (anciennement IDX-Tsunami) est un outil de test de monté en charge. Il peut être utilisé pour les services suivants : HTTP, WebDAV, SOAP, PostgreSQL, MySQL, AMQP, MQTT, LDAP et Jabber / XMPP.

L’atout principal de Tsung réside dans sa capacité à simuler un très grand nombre d’utilisateurs simultanés à partir d’une seule machine. Il peut être également utilisé en tirant parti de plusieurs machines, en mode cluster. Lorsqu'il est utilisé sur un cluster, il permet de générer une charge vraiment très impressionnante à partir d'un cluster modeste, facile à configurer et à gérer.

Tsung est développé en Erlang.

## Installation

Sous Debian

~~~
# aptitude install tsung
~~~

> *Note* : sur Debian 9 il y a [un souci](https://github.com/processone/tsung/issues/276) qui peut être contourné avec ces commandes :

~~~
# ln -s /usr/share /usr/lib/share
# ln -s /usr/lib/x86_64-linux-gnu/tsung /usr/lib/tsung
~~~

Sous OpenBSD :

~~~
# pkg_add tsung
~~~

## Utilisation

### Enregistrement d'une session

~~~
$ tsung-recorder start
…
$ tsung-recorder stop
~~~

### Créer un scenario de test

Dupliquer et compléter les entêtes XML grâces aux exemples dans /usr/share/doc/tsung/examples/

Un exemple :

~~~
<?xml version="1.0"?>                                                                       
<!DOCTYPE tsung SYSTEM "/usr/share/tsung/tsung-1.0.dtd">                                    
<tsung loglevel="notice" version="1.0">                                                     
                                                                                            
  <!-- Client side setup -->                                                                
  <clients>                                                                                 
    <client host="mamachine" maxusers="30000"/>                                            
  </clients>                                                                                
                                                                                            
  <!-- Server side setup -->                                                                
<servers>                                                                                   
  <server host="www.test.com" port="80" type="tcp"></server>                          
</servers>                                                                                  
                                                                                            
                                                                                            
<load duration="5" unit="minute">                                                          
  <arrivalphase phase="1" duration="5" unit="minute">                                       
    <users interarrival="1" unit="second"></users>     
   </arrivalphase>                         
</load>                                                                                     

<sessions>                                                                                  
<session name='test' probability='100'  type='ts_http'>   
<request><http url='<http://www.example.com'> version='1.1' method='GET'></<http></request>
[…]
</session>
</sessions>
</tsung>
~~~

### Lancer un scenario de test

~~~
tsung -f tsung-toto.xml start
~~~

### Consulter le test en cours

Tsung démarre un serveur web intégré et accessible sur [http://localhost:8091/]()

Cela permet de consulter les infos sur le test pendant son fonctionnement et même de stopper le test si on constate qu'il pose problème.

Si le test est lancé avec l'option `-k` le serveur web n'est pas arrêté lorsque le test est terminé.

### Générer les stats

~~~
cd ~/.tsung/log/20081103-16:21
/usr/lib/tsung/bin/tsung_stats.pl
~~~

## Améliorer les performances de Tsung

* ulimit
* Baisser le loglevel

## Mode multi clients

Il faut pouvoir se connecter en ssh via clé et sans passphrase.  
Il faut que le nom de machine du master résout sur les slaves. (On pourra modifier le fichier hosts).  
/!\\ Il faut la même version de tsung et erlang et des librairies sur chaque machine.  
/!\\ Il ne faut pas de pare-feu, des ports dynamiques sont ouverts pour communiquer entre le master et les slaves.  

## Erreur badmatch,{error,enoent}

Il faut créer des liens symboliques :

~~~
# ln -s /usr/share /usr/lib/share
# ln -s /usr/lib/x86_64-linux-gnu/tsung /usr/lib/tsung
~~~
